Open CASCADE Technology: OpenGl_BVHClipPrimitiveSet Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
OpenGl_BVHClipPrimitiveSet Class Reference

Set of OpenGl_Structures for building BVH tree. More...

`#include <OpenGl_BVHClipPrimitiveSet.hxx>`

Inheritance diagram for OpenGl_BVHClipPrimitiveSet:
[legend]

## Public Member Functions
| OpenGl_BVHClipPrimitiveSet ()
| Creates an empty primitive set for BVH clipping. More...
virtual Standard_Integer | Size () const
| Returns total number of structures. More...
virtual Graphic3d_BndBox4f | Box (const Standard_Integer theIdx) const
| Returns AABB of the structure. More...
virtual Standard_ShortReal | Center (const Standard_Integer theIdx, const Standard_Integer theAxis) const
| Calculates center of the AABB along given axis. More...
virtual void | Swap (const Standard_Integer theIdx1, const Standard_Integer theIdx2)
| Swaps structures with the given indices. More...
void | Assign (const OpenGl_ArrayOfIndexedMapOfStructure &theStructs)
| Replaces the set by the given array taking into account if each structure is cullable or not. More...
void | Add (const OpenGl_Structure *theStruct)
| Adds structure to the set. More...
void | Remove (const OpenGl_Structure *theStruct)
| Removes the given structure from the set. More...
void | Clear ()
| Cleans the whole primitive set. More...
const OpenGl_Structure * | GetStructureById (Standard_Integer theId)
| Returns the structure corresponding to the given ID. More...
Public Member Functions inherited from BVH_PrimitiveSet< Standard_ShortReal, 4 >
| BVH_PrimitiveSet ()
| Creates set of abstract primitives. More...
virtual | ~BVH_PrimitiveSet ()
| Releases resources of set of abstract primitives. More...
virtual BVH_Box< Standard_ShortReal, N > | Box () const
| Returns AABB of primitive set. More...
virtual const NCollection_Handle< BVH_Tree< Standard_ShortReal, N > > & | BVH ()
| Returns BVH tree (and builds it if necessary). More...
virtual const NCollection_Handle< BVH_Builder< Standard_ShortReal, N > > & | Builder () const
| Returns the method (builder) used to construct BVH. More...
virtual void | SetBuilder (NCollection_Handle< BVH_Builder< Standard_ShortReal, N > > &theBuilder)
| Sets the method (builder) used to construct BVH. More...
Public Member Functions inherited from BVH_Object< Standard_ShortReal, N >
| BVH_Object ()
| Creates new abstract geometric object. More...
virtual | ~BVH_Object ()=0
| Releases resources of geometric object. More...
virtual const NCollection_Handle< BVH_Properties > & | Properties () const
| Returns properties of the geometric object. More...
virtual void | SetProperties (const NCollection_Handle< BVH_Properties > &theProperties)
| Sets properties of the geometric object. More...
virtual void | MarkDirty ()
| Marks object state as outdated (needs BVH rebuilding). More...
Public Member Functions inherited from BVH_Set< Standard_ShortReal, N >
| BVH_Set ()
| Creates new abstract set of objects. More...
virtual | ~BVH_Set ()=0
| Releases resources of set of objects. More...

## Additional Inherited Members
Public Types inherited from BVH_Set< Standard_ShortReal, N >
typedef BVH_Box< Standard_ShortReal, N > | BVH_BoxNt
Protected Member Functions inherited from BVH_PrimitiveSet< Standard_ShortReal, 4 >
virtual void | Update ()
| Updates BVH of primitive set. More...
Protected Attributes inherited from BVH_PrimitiveSet< Standard_ShortReal, 4 >
NCollection_Handle< BVH_Tree< Standard_ShortReal, N > > | myBVH
| Constructed bottom-level BVH. More...
NCollection_Handle< BVH_Builder< Standard_ShortReal, N > > | myBuilder
| Builder for bottom-level BVH. More...
BVH_Box< Standard_ShortReal, N > | myBox
| Cached bounding box of geometric primitives. More...
Protected Attributes inherited from BVH_Object< Standard_ShortReal, N >
Standard_Boolean | myIsDirty
| Marks internal object state as outdated. More...
NCollection_Handle< BVH_Properties > | myProperties
| Generic properties assigned to the object. More...

## Detailed Description

Set of OpenGl_Structures for building BVH tree.

## Constructor & Destructor Documentation

OpenGl_BVHClipPrimitiveSet::OpenGl_BVHClipPrimitiveSet | ( |  | ) |

Creates an empty primitive set for BVH clipping.

## Member Function Documentation

void OpenGl_BVHClipPrimitiveSet::Add | ( | const OpenGl_Structure * | theStruct | ) |

Adds structure to the set.

void OpenGl_BVHClipPrimitiveSet::Assign | ( | const OpenGl_ArrayOfIndexedMapOfStructure & | theStructs | ) |

Replaces the set by the given array taking into account if each structure is cullable or not.

virtual Graphic3d_BndBox4f OpenGl_BVHClipPrimitiveSet::Box | ( | const Standard_Integer | theIdx | ) | const
| virtual

Returns AABB of the structure.

Implements BVH_Set< Standard_ShortReal, N >.

virtual Standard_ShortReal OpenGl_BVHClipPrimitiveSet::Center | ( | const Standard_Integer | theIdx,
|  | const Standard_Integer | theAxis
| ) |  | const
| virtual

Calculates center of the AABB along given axis.

Implements BVH_Set< Standard_ShortReal, N >.

void OpenGl_BVHClipPrimitiveSet::Clear | ( |  | ) |

Cleans the whole primitive set.

const OpenGl_Structure* OpenGl_BVHClipPrimitiveSet::GetStructureById | ( | Standard_Integer | theId | ) |

Returns the structure corresponding to the given ID.

void OpenGl_BVHClipPrimitiveSet::Remove | ( | const OpenGl_Structure * | theStruct | ) |

Removes the given structure from the set.

virtual Standard_Integer OpenGl_BVHClipPrimitiveSet::Size | ( |  | ) | const
| virtual

Returns total number of structures.

Implements BVH_Set< Standard_ShortReal, N >.

virtual void OpenGl_BVHClipPrimitiveSet::Swap | ( | const Standard_Integer | theIdx1,
|  | const Standard_Integer | theIdx2
| ) |  |
| virtual

Swaps structures with the given indices.

Implements BVH_Set< Standard_ShortReal, N >.

The documentation for this class was generated from the following file:

- OpenGl_BVHClipPrimitiveSet.hxx